'***********************************************************************
'
'    Filename        :     Deko-Licht.Bas		
'    File Version    :     1.0
'    Datum           :     10.06.2008            	
'    Autor           :     Peter Verderber		
'    Funktion        :     Deko-Lichtspiele	
'    Letzte Revision :     1.0
'    Datum           :     21.06.2008           
'    Ziel PIC        :     16F628A  	
'    Compiler        :     iL_BAS16 - Professional  V5.7-10  23.11.2007 
'    
'***********************************************************************
'*****                Definitionen und Konstanten                  *****
'***********************************************************************

Date
Time

$NCALDEF

'$LIST BIN          'erzeugt zustzlich eine Binrdatei 
'$LIST OBJ2HEX      'das Hexfile bekommt anstatt OBJ die Dateiendung HEX   

define device 16f628a,wdt_off,irc_osc,cmcfg7,MCLR_INT,OSC2_IO,T0CS_INT,PROTECT_OFF              
  
'xtal 4.0 

'$debug 3,ra,4
                      
tris ra,%000011
tris rb,%00000000          

output rb,%00000000

define zeit        = auto as word      'Zeit in Sekunden
define show_time   = auto as word      'Anzeigedauer je Muster
define time_scale  = $30 as byte       'Zeitfaktor x 500 msec
define menu        = $31 as byte       'Programm-Men

define muster_ra   = auto as byte      'Muster an Port RA
define muster_rb   = auto as byte      'Muster an Port RB
define zufall      = auto as byte      'Erzeugt eine Zufallszahl
define nn          = auto as byte      'Hilfsvariable 

define taste_time  = ra,0              'Taste Zeitfaktor
define taste_menu  = ra,1              'Taste Menu

clock zeit

goto main                              'Start Hauptprogramm

'***********************************************************************
'*****                   Unterprogramme                            *****
'***********************************************************************

init:                        'Variablen & Display initalisieren
  
  let show_time = 500        'Display einschalten
  
  let muster_ra = 0         
  let muster_rb = 0 
  
  gosub set_muster
  
  for nn = 1 to 3            'Display 3 mal blinken
    let muster_ra = 1       
    let muster_rb = 255
    gosub set_muster
    let muster_ra = 0         
    let muster_rb = 0 
    gosub set_muster
  next nn
  
  let time_scale = 2 
  let menu       = 0
  
return
     
'-----------------------------------------------------------------------

store_showtime:    'Faktor fr Anzeigezeit ins PIC-EEPROM schreiben

  write 0,time_scale                  
  wait 15
return 

'-----------------------------------------------------------------------

read_showtime:     'Faktor fr Anzeigezeit aus PIC-EEPROM lesen

  read 0,time_scale                   
  wait 15
return       

'-----------------------------------------------------------------------

store_menu:        'Menu ins PIC-EEPROM schreiben

  write 1,menu                  
  wait 15
return 

'-----------------------------------------------------------------------

read_menu:         'Menu aus PIC-EEPROM lesen

  read 1,menu                   
  wait 15
return       

'-----------------------------------------------------------------------

set_muster:                  'Muster anzeigen

  let muster_rb = muster_rb xor 255
  output rb,muster_rb
  if muster_ra = 1 then res ra,2 else set ra,2
  wait show_time
  
  if taste_time = 0 then wait 50         
  if taste_time = 0 then gosub select_timescale

  if taste_menu = 0 then wait 50
  if taste_menu = 0 then gosub select_menu
  
return	

'-----------------------------------------------------------------------

clear_muster:                'Muster lschen
  
  let muster_rb = 255
  set ra,2
  output rb,muster_rb
  wait show_time
  
  if taste_time = 0 then wait 50         
  if taste_time = 0 then gosub select_timescale

  if taste_menu = 0 then wait 50
  if taste_menu = 0 then gosub select_menu
    
return	

'-----------------------------------------------------------------------

select_timescale:            'Tastenabfrage Zeitfaktor

  let muster_rb = time_scale
  
  let muster_rb = muster_rb xor 255    'Binr-Anzeige Anzeigedauer  
  output rb,muster_rb
  if muster_ra = 1 then res ra,2 else set ra,2
 
  if taste_time = 0 then wait 50         
  if taste_time = 0 then goto inc_timescale

  if taste_menu = 0 then wait 50
  if taste_menu = 0 then goto exit_timescale

  goto select_timescale
    
  inc_timescale:
    inc time_scale
    if time_scale > 120 then let time_scale = 1
    let muster_rb = time_scale
    
    let muster_rb = muster_rb xor 255
    output rb,muster_rb
    if muster_ra = 1 then res ra,2 else set ra,2
    
    if taste_menu = 0 then wait 50
    if taste_menu = 0 then goto exit_timescale  
  
    wait 200
   
  goto select_timescale
   
  exit_timescale:
    gosub store_showtime
    gosub clear_muster
    goto loop     
return

'----------------------------------------------------------------------- 

select_menu:            'Tastenabfrage Menu

  let muster_rb = menu
     
  let muster_rb = muster_rb xor 255    'Binr-Anzeige Menu  
  output rb,muster_rb
  if muster_ra = 1 then res ra,2 else set ra,2
  
  if taste_menu = 0 then wait 50         
  if taste_menu = 0 then goto inc_menu

  if taste_time = 0 then wait 50
  if taste_time = 0 then goto exit_menu
  
  goto select_menu
    
  inc_menu:
    inc menu
    if menu > 2 then let menu = 0
    let muster_rb = menu
    
    let muster_rb = muster_rb xor 255
    output rb,muster_rb
    if muster_ra = 1 then res ra,2 else set ra,2
    
    if taste_time = 0 then wait 50
    if taste_time = 0 then goto exit_menu 
  
    wait 200
         
  goto select_menu
   
  exit_menu:
    gosub store_menu
    gosub clear_muster
    goto loop 
return

'----------------------------------------------------------------------- 
$troff

muster_001:        'Rotierender Punkt im Uhrzeigersinn        
  
  let muster_ra = 0          'B0 B1 B2           1   2    4  
  let muster_rb = 1          'B3 A2 B4           8   0   16 
  gosub set_muster           'B5 B6 B7          32  64  128 
  let muster_rb = 2                                    
  gosub set_muster
  let muster_rb = 4                                    
  gosub set_muster       
  let muster_rb = 16                                    
  gosub set_muster
  let muster_rb = 128                                   
  gosub set_muster
  let muster_rb = 64                                    
  gosub set_muster
  let muster_rb = 32                                    
  gosub set_muster
  let muster_rb = 8                                    
  gosub set_muster
  let muster_rb = 1                                    
  gosub set_muster
  
  gosub clear_muster
  
return  

'----------------------------------------------------------------------- 

muster_002:        'Rotierender Punkt gegen Uhrzeigersinn        
  
  let muster_ra = 0          'B0 B1 B2           1   2    4           
  let muster_rb = 1          'B3 A2 B4           8   0   16
  gosub set_muster           'B5 B6 B7          32  64  128
  let muster_rb = 8                                    
  gosub set_muster
  let muster_rb = 32                                    
  gosub set_muster       
  let muster_rb = 64                                    
  gosub set_muster
  let muster_rb = 128                                   
  gosub set_muster
  let muster_rb = 16                                    
  gosub set_muster
  let muster_rb = 4                                    
  gosub set_muster
  let muster_rb = 2                                    
  gosub set_muster
  let muster_rb = 1                                    
  gosub set_muster
  let muster_rb = 0
  
  gosub clear_muster
  
return  
 
'----------------------------------------------------------------------- 
  
muster_003:        'Rotierender Balken im Uhrzeigersinn        
  
  let muster_ra = 1          'B0 B1 B2           1   2    4           
  let muster_rb = 66         'B3 A2 B4           8   0   16
  gosub set_muster           'B5 B6 B7          32  64  128
  let muster_rb = 36                                   
  gosub set_muster
  let muster_rb = 24                                    
  gosub set_muster       
  let muster_rb = 129                                    
  gosub set_muster
  let muster_rb = 66                                    
  gosub set_muster
  
  gosub clear_muster
  
return  
 
'----------------------------------------------------------------------- 
    
muster_004:        'Rotierender Balken gegen Uhrzeigersinn        
  
  let muster_ra = 1          'B0 B1 B2           1   2    4           
  let muster_rb = 66         'B3 A2 B4           8   0   16
  gosub set_muster           'B5 B6 B7          32  64  128
  let muster_rb = 129                                   
  gosub set_muster
  let muster_rb = 24                                    
  gosub set_muster       
  let muster_rb = 36
  gosub set_muster 
  let muster_rb = 66                                    
  gosub set_muster
  
  gosub clear_muster
   
return  
 
'----------------------------------------------------------------------- 
     
muster_005:        'Balken von oben nach unten        
  
  let muster_ra = 0          'B0 B1 B2           1   2    4           
  let muster_rb = 7          'B3 A2 B4           8   0   16
  gosub set_muster           'B5 B6 B7          32  64  128
  let muster_ra = 1
  let muster_rb = 24                                   
  gosub set_muster
  let muster_ra = 0
  let muster_rb = 224
  gosub set_muster                                    
  
  gosub clear_muster
      
return  
 
'----------------------------------------------------------------------- 

muster_006:        'Balken von unten nach oben        
  
  let muster_ra = 0          'B0 B1 B2           1   2    4           
  let muster_rb = 224        'B3 A2 B4           8   0   16
  gosub set_muster           'B5 B6 B7          32  64  128
  let muster_ra = 1
  let muster_rb = 24                                   
  gosub set_muster
  let muster_ra = 0
  let muster_rb = 7                                    
  gosub set_muster
  
  gosub clear_muster
    
return  
 
'----------------------------------------------------------------------- 
          
muster_007:        'Balken von links oben nach rechts unten        
  
  let muster_ra = 0          'B0 B1 B2           1   2    4           
  let muster_rb = 1          'B3 A2 B4           8   0   16
  gosub set_muster           'B5 B6 B7          32  64  128
  let muster_rb = 10
  gosub set_muster
  let muster_ra = 1
  let muster_rb = 36                                   
  gosub set_muster
  let muster_ra = 0
  let muster_rb = 80
  gosub set_muster
  let muster_rb = 128
  gosub set_muster                                    
  
  gosub clear_muster
    
return  
 
'----------------------------------------------------------------------- 
          
muster_008:        'Balken von rechts unten nach links oben        
  
  let muster_ra = 0          'B0 B1 B2           1   2    4           
  let muster_rb = 128        'B3 A2 B4           8   0   16
  gosub set_muster           'B5 B6 B7          32  64  128
  let muster_rb = 80
  gosub set_muster
  let muster_ra = 1
  let muster_rb = 36                                   
  gosub set_muster
  let muster_ra = 0
  let muster_rb = 10
  gosub set_muster
  let muster_rb = 1
  gosub set_muster                                    
  
  gosub clear_muster
    
return  
 
'----------------------------------------------------------------------- 
                    
muster_009:        'Balken von rechts oben nach links unten        
  
  let muster_ra = 0          'B0 B1 B2           1   2    4           
  let muster_rb = 4          'B3 A2 B4           8   0   16
  gosub set_muster           'B5 B6 B7          32  64  128
  let muster_rb = 18
  gosub set_muster
  let muster_ra = 1
  let muster_rb = 129                                   
  gosub set_muster
  let muster_ra = 0
  let muster_rb = 72
  gosub set_muster
  let muster_rb = 32
  gosub set_muster
  
  gosub clear_muster                                    
    
return  
 
'----------------------------------------------------------------------- 
         
muster_010:        'Balken von links unten nach rechts oben        
  
  let muster_ra = 0          'B0 B1 B2           1   2    4           
  let muster_rb = 32         'B3 A2 B4           8   0   16
  gosub set_muster           'B5 B6 B7          32  64  128
  let muster_rb = 72
  gosub set_muster
  let muster_ra = 1
  let muster_rb = 129                                   
  gosub set_muster
  let muster_ra = 0
  let muster_rb = 18
  gosub set_muster
  let muster_rb = 4
  gosub set_muster
  
  gosub clear_muster                                    
    
return  
 
'----------------------------------------------------------------------- 

muster_011:        'Schachbrett        
  
  let muster_ra = 1          'B0 B1 B2           1   2    4           
  let muster_rb = 165        'B3 A2 B4           8   0   16
  gosub set_muster           'B5 B6 B7          32  64  128
  
  gosub clear_muster
     
return  
 
'----------------------------------------------------------------------- 

muster_012:        'Schachbrett invers        
  
  let muster_ra = 0          'B0 B1 B2           1   2    4           
  let muster_rb = 90         'B3 A2 B4           8   0   16
  gosub set_muster           'B5 B6 B7          32  64  128
  
  gosub clear_muster
     
return  
 
'----------------------------------------------------------------------- 

muster_013:        'Rotierendes Dreieck im Uhrzeigersinn        
  
  let muster_ra = 0          'B0 B1 B2           1   2    4           
  let muster_rb = 11         'B3 A2 B4           8   0   16
  gosub set_muster           'B5 B6 B7          32  64  128
  let muster_rb = 22                                   
  gosub set_muster
  let muster_rb = 208                                    
  gosub set_muster       
  let muster_rb = 104
  gosub set_muster
  let muster_rb = 11
  gosub set_muster
  
  gosub clear_muster                                    
   
return  
 
'----------------------------------------------------------------------- 

 muster_014:        'Rotierendes Dreieck gegen Uhrzeigersinn        
  
  let muster_ra = 0          'B0 B1 B2           1   2    4           
  let muster_rb = 11         'B3 A2 B4           8   0   16
  gosub set_muster           'B5 B6 B7          32  64  128
  let muster_rb = 104                                  
  gosub set_muster
  let muster_rb = 208                                    
  gosub set_muster       
  let muster_rb = 22
  gosub set_muster
  let muster_rb = 11
  gosub set_muster
  
  gosub clear_muster                                     
   
return  
 
'----------------------------------------------------------------------- 
 
muster_015:        'Rotierendes Pfeil im Uhrzeigersinn        
  
  let muster_ra = 1          'B0 B1 B2           1   2    4           
  let muster_rb = 5          'B3 A2 B4           8   0   16
  gosub set_muster           'B5 B6 B7          32  64  128
  let muster_rb = 132                                  
  gosub set_muster
  let muster_rb = 160                                    
  gosub set_muster       
  let muster_rb = 33
  gosub set_muster 
  let muster_rb = 5
  gosub set_muster
  
  gosub clear_muster                                    
   
return  
 
'----------------------------------------------------------------------- 
         
muster_016:        'Rotierendes Pfeil gegen Uhrzeigersinn        
  
  let muster_ra = 1          'B0 B1 B2           1   2    4           
  let muster_rb = 5          'B3 A2 B4           8   0   16
  gosub set_muster           'B5 B6 B7          32  64  128
  let muster_rb = 33                                  
  gosub set_muster
  let muster_rb = 160                                    
  gosub set_muster       
  let muster_rb = 132
  gosub set_muster
  let muster_rb = 5
  gosub set_muster
  
  gosub clear_muster                                      
   
return  
 
'----------------------------------------------------------------------- 
         
muster_017:        'Rotierender Strich im Uhrzeigersinn        
  
  let muster_ra = 1          'B0 B1 B2           1   2    4  
  let muster_rb = 1          'B3 A2 B4           8   0   16 
  gosub set_muster           'B5 B6 B7          32  64  128 
  let muster_rb = 2                                    
  gosub set_muster
  let muster_rb = 4                                    
  gosub set_muster       
  let muster_rb = 16                                    
  gosub set_muster
  let muster_rb = 128                                   
  gosub set_muster
  let muster_rb = 64                                    
  gosub set_muster
  let muster_rb = 32                                    
  gosub set_muster
  let muster_rb = 8                                    
  gosub set_muster
  let muster_rb = 1                                    
  gosub set_muster
  
  gosub clear_muster
  
return
 
'----------------------------------------------------------------------- 

muster_018:        'Rotierender Strich gegen Uhrzeigersinn        
 
  let muster_ra = 1          'B0 B1 B2           1   2    4           
  let muster_rb = 1          'B3 A2 B4           8   0   16
  gosub set_muster           'B5 B6 B7          32  64  128
  let muster_rb = 8                                    
  gosub set_muster
  let muster_rb = 32                                    
  gosub set_muster       
  let muster_rb = 64                                    
  gosub set_muster
  let muster_rb = 128                                   
  gosub set_muster
  let muster_rb = 16                                    
  gosub set_muster
  let muster_rb = 4                                    
  gosub set_muster
  let muster_rb = 2                                    
  gosub set_muster
  let muster_rb = 1                                    
  gosub set_muster
  let muster_rb = 0
  
  gosub clear_muster
  
return  
 
'----------------------------------------------------------------------- 

muster_019:        'Zufall 

for nn = 1 to 30
  random zufall       
  let muster_ra = 1          'B0 B1 B2           1   2    4           
  let muster_rb = zufall     'B3 A2 B4           8   0   16
  gosub set_muster           'B5 B6 B7          32  64  128
  random zufall
  let muster_ra = 0         
  let muster_rb = zufall 
  gosub set_muster  
next nn  

  gosub clear_muster 
                  
return  
 
'----------------------------------------------------------------------- 

muster_020:        'Wrfel von 1 bis 6       
  
  let muster_ra = 1          'B0 B1 B2           1   2    4           
  let muster_rb = 0          'B3 A2 B4           8   0   16
  gosub set_muster           'B5 B6 B7          32  64  128
  gosub clear_muster
  
  let muster_ra = 0
  let muster_rb = 129
  gosub set_muster
  gosub clear_muster
  
  let muster_ra = 1
  let muster_rb = 129                                   
  gosub set_muster
  gosub clear_muster
  
  let muster_ra = 0
  let muster_rb = 165
  gosub set_muster
  gosub clear_muster
  
  let muster_ra = 1
  let muster_rb = 165
  gosub set_muster 
  gosub clear_muster
  
  let muster_ra = 0
  let muster_rb = 189
  gosub set_muster
  gosub clear_muster
    
return  
 
'----------------------------------------------------------------------- 
     
muster_021:         'Symbol +        
  
  let muster_ra = 1          'B0 B1 B2           1   2    4           
  let muster_rb = 90         'B3 A2 B4           8   0   16
  gosub set_muster           'B5 B6 B7          32  64  128
  gosub clear_muster  
return  
 
'----------------------------------------------------------------------- 
     
muster_022:         'Symbol -        
  
  let muster_ra = 1          'B0 B1 B2           1   2    4           
  let muster_rb = 24         'B3 A2 B4           8   0   16
  gosub set_muster           'B5 B6 B7          32  64  128
  gosub clear_muster
    
return  
 
'----------------------------------------------------------------------- 
      
 muster_023:         'Symbol /        
  
  let muster_ra = 1          'B0 B1 B2           1   2    4           
  let muster_rb = 36         'B3 A2 B4           8   0   16
  gosub set_muster           'B5 B6 B7          32  64  128
  gosub clear_muster
    
return  
 
'----------------------------------------------------------------------- 

muster_024:         'Symbol \        
  
  let muster_ra = 1          'B0 B1 B2           1   2    4           
  let muster_rb = 129        'B3 A2 B4           8   0   16
  gosub set_muster           'B5 B6 B7          32  64  128
  gosub clear_muster
    
return  
 
'----------------------------------------------------------------------- 

 muster_025:         'Symbol .        
  
  let muster_ra = 1          'B0 B1 B2           1   2    4           
  let muster_rb = 0          'B3 A2 B4           8   0   16
  gosub set_muster           'B5 B6 B7          32  64  128
  gosub clear_muster
    
return  
 
'----------------------------------------------------------------------- 

muster_026:         'Symbol 0        
  
  let muster_ra = 0          'B0 B1 B2           1   2    4           
  let muster_rb = 255        'B3 A2 B4           8   0   16
  gosub set_muster           'B5 B6 B7          32  64  128
  gosub clear_muster
    
return  
 
'----------------------------------------------------------------------- 

muster_027:         'Alles an        
  
  let muster_ra = 1          'B0 B1 B2           1   2    4           
  let muster_rb = 255        'B3 A2 B4           8   0   16
  gosub set_muster           'B5 B6 B7          32  64  128
    
return  
 
'----------------------------------------------------------------------- 

muster_028:         'Alles aus      
  
  gosub clear_muster         'B0 B1 B2           1   2    4           
                             'B3 A2 B4           8   0   16
                             'B5 B6 B7          32  64  128
    
return  
 
'***********************************************************************
'*****                     Hauptprogramm                           *****
'***********************************************************************
$tron

main:
  gosub init                 'Variablen initialisieren

  loop:
  
    gosub read_menu
    if menu > 2 then let menu = 0
  
    gosub read_showtime
    if time_scale = 0   then let time_scale = 1
    if time_scale > 120 then let time_scale = 1
    let show_time = time_scale * 500
         
    on menu gosub muster_serie, muster_zufall, muster_dauer       
  
  goto loop 
         
  muster_serie:                      
    gosub muster_001
    gosub muster_002
    gosub muster_003
    gosub muster_004
    gosub muster_005
    gosub muster_006
    gosub muster_007
    gosub muster_008
    gosub muster_009
    gosub muster_010
    gosub muster_011
    gosub muster_012
    gosub muster_013
    gosub muster_014
    gosub muster_015
    gosub muster_016
    gosub muster_017
    gosub muster_018
    gosub muster_019
    gosub muster_020
    gosub muster_021
    gosub muster_022
    gosub muster_023
    gosub muster_024
    gosub muster_025
    gosub muster_026
    gosub muster_027
    gosub muster_028
  return     
   
  muster_zufall:  
    gosub muster_019
  return
  
  muster_dauer:
    gosub muster_027     
  return        
       
goto main       

end                          'Ende gut, alles gut       
        
       